Index: /XIOS/dev/dev_olga/src/node/axis.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/axis.hpp	(revision 1128)
+++ /XIOS/dev/dev_olga/src/node/axis.hpp	(revision 1129)
@@ -78,9 +78,4 @@
          int getOffsetWrittenIndexes() const;
 
-         int getStartWriteIndex() const;
-         int getCountWriteIndex() const;
-         int getLocalWriteSize() const;
-         int getGlobalWriteSize() const;
-
          std::map<int, StdSize> getAttributesBufferSize();
 
@@ -119,4 +114,5 @@
          void checkEligibilityForCompressedOutput();
 
+         void computeWrittenIndex();
          bool hasTransformation();
          void solveInheritanceTransformation();
@@ -134,4 +130,5 @@
         CArray<int,1> globalDimGrid;
         int orderPosInGrid;
+        CArray<size_t,1> localIndexToWriteOnServer;
 
       private:
@@ -176,10 +173,6 @@
          bool hasBounds_;
 
-         int start_write_index_;
-         int count_write_index_;
-         int local_write_size_;
-         int global_write_size_;
-
          bool doZoomByIndex_;
+         bool computedWrittenIndex_;
 
        private:
Index: /XIOS/dev/dev_olga/src/node/context.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/context.cpp	(revision 1128)
+++ /XIOS/dev/dev_olga/src/node/context.cpp	(revision 1129)
@@ -572,12 +572,11 @@
     postProcessingGlobalAttributes();
 
-    if (hasClient) sendPostProcessingGlobalAttributes();
-
-    // There are some processings that should be done after all of above. For example: check mask or index
+    if (hasClient) sendPostProcessingGlobalAttributes();   
+    
     this->buildFilterGraphOfEnabledFields();
     
-     if (hasClient && !hasServer)
+    if (hasClient && !hasServer)
     {
-      buildFilterGraphOfFieldsWithReadAccess();
+      buildFilterGraphOfFieldsWithReadAccess();      
     }
 
@@ -623,4 +622,5 @@
      {
        this->enabledFiles[i]->solveOnlyRefOfEnabledFields(false);
+       // this->enabledFiles[i]->solveAllReferenceEnabledField(false);
      }
 
@@ -663,17 +663,12 @@
        this->enabledFiles[i]->generateNewTransformationGridDest();
      }
-
-     for (int i = 0; i < size; ++i)
-     {
-       //this->enabledFiles[i]->checkGridOfEnabledFields();
-     }
-   }
-
-   void CContext::solveAllRefOfEnabledFields(bool sendToServer)
+   }
+
+   void CContext::solveAllRefOfEnabledFieldsAndTransform(bool sendToServer)
    {
      int size = this->enabledFiles.size();
      for (int i = 0; i < size; ++i)
      {
-       this->enabledFiles[i]->solveAllRefOfEnabledFields(sendToServer);
+       this->enabledFiles[i]->solveAllRefOfEnabledFieldsAndTransform(sendToServer);
      }
    }
@@ -1168,6 +1163,6 @@
 
       // Search and rebuild all reference object of enabled fields, and transform
-      this->solveAllEnabledFields();
-
+      // this->solveAllEnabledFields
+      this->solveAllRefOfEnabledFieldsAndTransform(false);
       // // Check grid and calculate its distribution
       // if (hasClient) checkGridEnabledFields();
Index: /XIOS/dev/dev_olga/src/node/context.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/context.hpp	(revision 1128)
+++ /XIOS/dev/dev_olga/src/node/context.hpp	(revision 1129)
@@ -114,6 +114,5 @@
          void checkAxisDomainsGridsEligibilityForCompressedOutput();
          void prepareTimeseries(void);
-         void solveOnlyRefOfEnabledFields(bool sendToServer);
-         void solveAllRefOfEnabledFields(bool sendToServer);
+         void solveOnlyRefOfEnabledFields(bool sendToServer);         
          void buildFilterGraphOfEnabledFields();
          void startPrefetchingOfEnabledReadModeFiles();
@@ -125,4 +124,5 @@
          void postProcessingGlobalAttributes();         
 
+         void solveAllRefOfEnabledFieldsAndTransform(bool sendToServer);
          void solveAllEnabledFields();
          void checkGridEnabledFields();
